/*
ScriptName: MeasureIt.js
Application: Adobe Illustrator
Application versions: 11, 12 (CS, CS2)
Author: kaa(tm)
Dedicated to: Eu888
Script version: 1.0
Description languages: RU
Description [RU]:
       
        
 - ,  ,    
     ,   .
           
  yOffset,     ( ).
:
-  :   Point.      , 
         .
,        var Point = 1;
  --- var Point = 1/72;
-   :   myFontSize
-   :   myFont
-  :   Accuracy,     
    AccuracySet,     :
  AccuracySet[0] -- "ceil" --     
  AccuracySet[1] -- "floor" --     
  AccuracySet[2] -- "round" --    
  AccuracySet[3] --      0  12 --    
 -     ,   4   
*/

var myDoc = app.activeDocument;
var groupsCount = myDoc.groupItems.length;
var mySelection = myDoc.selection;
var Point = 25.4/72;
var myFont = app.textFonts.getByName("Arial-ItalicMT");
var myFontSize = 8;
var yOffset = 10;
var AccuracySet = ["ceil","floor","round",2];
var Accuracy = AccuracySet[0];

if (mySelection.length != 0) {
	var newGroup = myDoc.groupItems.add(); 
	for (var i = 0; i  < mySelection.length; i++) {
		mySelection[i].duplicate(newGroup, ElementPlacement.PLACEATEND);
		}
	setLabel(newGroup, Accuracy);
	newGroup.remove();
	redraw();
} else 

if (groupsCount != 0) {
	for (var i = 0; i  < groupsCount; i++) {
		var Target = myDoc.groupItems[i];
		if (Target.parent.typename != "GroupItem") {
		setLabel(Target, Accuracy);	}
	}
	}
else 
	{
	alert("Neither objects selected nor groups found!");
	}

function setLabel(aGroup, acc) {
	switch (acc) {
	case AccuracySet[0]:
		selHeight = Math.ceil(aGroup.height*Point);
		selWidth = Math.ceil(aGroup.width*Point);
	break;
	case AccuracySet[1]:
		selHeight = Math.floor(aGroup.height*Point);
		selWidth = Math.floor(aGroup.width*Point);
	break;
	case AccuracySet[2]:
		selHeight = Math.floor(aGroup.height*Point);
		selWidth = Math.floor(aGroup.width*Point);
	break;
	case AccuracySet[3]:
		mult = Math.pow(10, acc);
		selHeight = Math.round(aGroup.height*mult*Point)/mult;
		selWidth = Math.round(aGroup.width*mult*Point)/mult;
	break;
	default:
		mult = 10000;
		selHeight = Math.round(aGroup.height*10000*Point)/10000;
		selWidth = Math.round(aGroup.width*10000*Point)/10000;
	break;
	}
	myMsg = "Size: "+ selWidth+"\u00D7"+selHeight+" mm";
	myBounds = aGroup.controlBounds;
	var myLabel = myDoc.layers[0].textFrames.add();
	myLabel.contents = myMsg;
	myLabel.textRange.characterAttributes.size = myFontSize;
	myLabel.textRange.characterAttributes.textFont = myFont;
	myLabel.position = [myBounds[0], myBounds[3]-yOffset/Point];
}